//+------------------------------------------------------------------+
//|                                         Daily Hi-Lo Breakout.mq4 |
//|                                                   Amritendu Maji |
//+------------------------------------------------------------------+
#property copyright "Amritendu Maji"
#property link      "http://www.strategybuilderfx.com/forums/showthread.php?t=15761&page=4&pp=8"

extern double Lots=1.0;
extern int Slippage=3;
extern string EAName = "Daily Hi-Lo Breakout";
extern int MagicNumber = 1568;

extern int MaxTrades = 1;

extern int GMTShift=0; //2 is for Alpari, for IBFX should be 0

extern int TimeAHour=8;
extern int TimeAMin=0;

extern int LiveHour=23;
extern int LiveMin=0;

extern double LookBackHour=24;
extern int MaxOpenTradeHours = 23;
extern int MaxOpenTradeMins = 0;

extern double StopLossPips = 30; 
extern double ProfitPips = 20; 
extern double StretchPips = 7; 
extern double MinRangePips = 1;

bool runnable=true;
bool init=true;

int AdjustedEntryHour;

datetime timeprev=0;
datetime expiration, exittime;
int LookBack;
double Lo, Hi, Range, Stop, LongEntry, ShortEntry, StopLoss, TakeProfit;
double price, prcopp, Stretch, Trail, TrailStart;

int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{
//Runnable
 if(runnable!=true)
  return(-1);
  
//Init
 if(init==true)
 {
 }//Init

 
//  TrailingAlls(TrailStart, Trail); 
 
//Check for New Bar

 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 
 LookBack = MathCeil((LookBackHour*60)/Period());
 
// AdjustedEntryHour = USDayLightSavingsAdjustment(TimeAHour);
 AdjustedEntryHour = DSTAdjustment(TimeAHour);

 if(Time[0] >= exittime) CloseAll(MagicNumber);
 
 if((TimeHour(Time[0])==(AdjustedEntryHour+GMTShift) && TimeMinute(Time[0])==TimeAMin))
 {

  expiration=Time[0]+(LiveHour*60*60)+(LiveMin*60);
  exittime = Time[0]+ (MaxOpenTradeHours*60*60)+(MaxOpenTradeMins*60);

  Hi = iHigh(NULL, 0, Highest(NULL,0,MODE_HIGH,LookBack,1));
  Lo = iLow(NULL, 0, Lowest(NULL,0, MODE_LOW,LookBack,1));

  Range = Hi - Lo;
  if (Range < MinRangePips*Point)  return(0);
    
  Stretch = NormalizeDouble(StretchPips*Point, Digits);
  LongEntry = Hi + Stretch + (Ask-Bid);
  ShortEntry = Lo - Stretch;  
   
  Stop = StopLossPips*Point;
  if (Stop > (LongEntry - ShortEntry)) Stop = (LongEntry - ShortEntry); 
  
  StopLoss = NormalizeDouble((Stop/Point), 0);
  TakeProfit = ProfitPips; 
      
//Long
  price=LongEntry;
  prcopp=LongEntry ;
  OpenPendingOrder(OP_BUYSTOP,Lots,price,Slippage,prcopp,StopLoss,TakeProfit,EAName,MagicNumber,expiration,Green);
  
//Shrt
  price=ShortEntry;
  prcopp=ShortEntry;
  OpenPendingOrder(OP_SELLSTOP,Lots,price,Slippage,prcopp,StopLoss,TakeProfit,EAName,MagicNumber,expiration,Red);
 }//Open Pending
 
// MaintainMaxOpenTrades(MaxTrades);

 return(0);
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}


void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
  }//Shrt
  
 }//for
}

int DSTAdjustment(int HourUsed)
{
   int DST = 0;
   
   if (Month() > 3 && Month() < 10) {
      DST = 1;
   } else if (Month() == 3) {
      if (Day() + (7 - DayOfWeek()) > 31) {
         DST = 1;
      }
   } else if (Month() == 10) {
      if (Day() + (7 - DayOfWeek()) <= 31) {
         DST = 1;
      }
   }
   
   if (DST == 1) {
      return (HourUsed - 1);
   } else {
      return (HourUsed);
   }
}

void MaintainMaxOpenTrades(int max)
{
   int trade;
   int count;
   
   if (max > 0) {
      for (trade = OrdersTotal() - 1; trade >= 0; trade--) {
         if (OrderSelect(trade, SELECT_BY_POS)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
               if (OrderType() == OP_SELL || OrderType() == OP_BUY) {
                  count++;
               }
            }
         }
      }
   
      if (count >= max) {
         for (trade = OrdersTotal() - 1; trade >= 0; trade--) {
            if (OrderSelect(trade, SELECT_BY_POS)) {
               if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
                  if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) {
                     OrderDelete(OrderTicket());
                  }
               }
            }
         }
      }
   }
}

int USDayLightSavingsAdjustment(int HourUsed)
{
   int DST = 0;
   
   if (Month() > 4 && Month() < 10) {
      DST = 1;
   } else if (Month() == 4) {
      if ((Day() - DayOfWeek()) > 0) {
         DST = 1;
      }
   } else if (Month() == 10) {
      if (Day() + (7 - DayOfWeek()) <= 31) {
         DST = 1;
      }
   }
   
   if (DST == 1) {
      return (HourUsed - 1);
   } else {
      return (HourUsed);
   }
}

void CloseAll(int MagicNum)
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNum)
  {
   if(OrderType()==OP_BUY)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);

   if(OrderType()==OP_SELL)
    OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
  }
 }
}

int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(1000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}  



